﻿using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Windows.Forms;

namespace OrologioFotorealistico
{
    public partial class Form1 : Form
    {
        double gradiSecondi;
        double gradiMinuti;
        double gradiOre;
        short Xq; // coordinate mouse
        short Yq; // coordinate mouse
        Color coloreTrasparenza = Color.Empty;
        int immagine = 0; // indice in ListImage Imagesfondi dello sfondo
        short H = 3; // = 0 vengono visualizzate le lancette nere; = 3 di metallo
        short M = 3; // = 0 vengono visualizzate le lancette nere; = 3 di metallo
        short S = 3; // = 0 vengono visualizzate le lancette nere; = 3 di metallo
        Bitmap colorDesktop = new Bitmap(1, 1, PixelFormat.Format24bppRgb); // conterrà 1 pixel copiato dal desktop, alla posizione dell'orologio, sopra le ore 12
        Graphics gc; // per catturare il colore di un pixel del desktop
        Image topImg; // conterrà la composizione sfondo + lancette

        public Form1()
        {
            InitializeComponent();
            
            gc = Graphics.FromImage(colorDesktop); // per catturare il colore di un pixel del desktop
            topImg = new Bitmap(Imagesfondi.Images[0].Width, Imagesfondi.Images[0].Height); // dimensione da ImageSfondi
            Timer1_Tick(Timer1, EventArgs.Empty); // quando apparirà il form, l'orologio sarà già visibile
        }

        private void Timer1_Tick(System.Object sender, System.EventArgs e)
        {
            DateTime orario = DateTime.Now;

            gradiSecondi = 6 * orario.Second;
            if (Timer1.Interval < 1000) // con Timer1.interval = 62 lo scorrimento della lancetta dei secondi è fluido
                gradiSecondi += orario.Millisecond / 166.0;

            gradiMinuti = orario.Minute * 6 + orario.Second / 10.0; // scorrimento fluido dei minuti, 1 grado ogni 10 secondi
            gradiOre = orario.Hour * 30 + orario.Minute / 2.0; // scorrimento fluido delle ore, 1 grado ogni 2 minuti
            topImg = Imagesfondi.Images[immagine]; // lo sfondo scelto (quadrante)
            float Hsize = topImg.Height;
            float Wsize = topImg.Width;
            float HCentro = Hsize / 2 * -1; // posizione lancette
            float WCentro = Wsize / 2 * -1; // posizione lancette
            Graphics gt = Graphics.FromImage(topImg); // per il disegno lancette sopra al quadrante
            gt.SmoothingMode = SmoothingMode.AntiAlias; // qualità disegno
            gt.TranslateTransform(Wsize / 2, Hsize / 2); // coordinate al centro
            gt.RotateTransform((float)gradiOre); // rotazione in gradi lancetta ore
            gt.DrawImage(ImageLancette.Images[2 + H], WCentro, HCentro, Wsize, Hsize); // H base indice per tipo lancetta
            gt.RotateTransform((float)(gradiMinuti - gradiOre)); // rotazione in gradi lancetta minuti
            gt.DrawImage(ImageLancette.Images[1 + M], WCentro, HCentro, Wsize, Hsize); // M base indice per tipo lancetta
            gt.RotateTransform((float)(gradiSecondi - gradiMinuti)); // rotazione in gradi lancetta secondi
            gt.DrawImage(ImageLancette.Images[0 + S], WCentro, HCentro, Wsize, Hsize); // S base indice per tipo lancetta

            picQuadrante.Image = topImg; // composizione quadrante + lancette, nella picturebox
            if (this.TopMost)
            {
                // lettura colore pixel del desktop, alle coordinate della picturebox (sopra ore 12)
                coloreTrasparenza = GetColorAt(Convert.ToInt16(this.Left + picQuadrante.Width / 2.0), this.Top + picQuadrante.Top - 1);
                // il colore rilevato sul desktop determina il colore per la trasparenza in modo che non si noti la scalettatura
                this.TransparencyKey = coloreTrasparenza;
                this.BackColor = coloreTrasparenza;
            }
            else
            {
                this.Text = orario + " - CB©2025"; // data e ora sulla barra del form se visibile
            }
            gt.Dispose();           
        }

        private void Buttons_Click(object sender, EventArgs e)
        {
            Button bt = (Button)sender;
            immagine = Convert.ToInt16(bt.Text) - 1; // stessa routine per 6 bottoni
            picQuadrante.BackgroundImage = Imagesfondi.Images[immagine]; // carico lo sfondo scelto, indice preso dal nome del bottone
        }

        private void Button7_Click(object sender, EventArgs e)
        {
            if (S == 0) S = 3; else S = 0;// operazione flip/flop tra 0 e 3, cambia la base di partenza per il tipo di lancette
        }

        private void Button8_Click(object sender, EventArgs e)
        {
            if (M == 0) M = 3; else M = 0; // operazione flip/flop tra 0 e 3, cambia la base di partenza per il tipo di lancette
        }

        private void Button9_Click(object sender, EventArgs e)
        {
            if (H == 0) H = 3; else H = 0; // operazione flip/flop tra 0 e 3, cambia la base di partenza per il tipo di lancette
        }

        private void picQuadrante_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                Xq = Convert.ToInt16(e.X); // coordinata X mouse nel form, al momento del click tasto sinistro
                Yq = Convert.ToInt16(e.Y); // coordinata Y mouse nel form, al momento del click tasto sinistro
            }
        }

        private void picQuadrante_MouseMove(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                this.Top = this.Top + e.Y - Yq; // trascinamento Y sul desktop
                this.Left = this.Left + e.X - Xq; // trascinamento X sul desktop
            }
        }

        private void picQuadrante_DoubleClick(object sender, EventArgs e)
        {
            // gestione sparisci form
            Button1.Visible = this.TopMost;
            Button2.Visible = this.TopMost;
            Button3.Visible = this.TopMost;
            Button4.Visible = this.TopMost;
            Button5.Visible = this.TopMost;
            Button6.Visible = this.TopMost;
            Button7.Visible = this.TopMost;
            Button8.Visible = this.TopMost;
            Button9.Visible = this.TopMost;
            ComboBox1.Visible = this.TopMost;
            btnInfo.Visible = this.TopMost;
            this.ShowInTaskbar = this.TopMost;
            this.TopMost = !this.TopMost; //prima dell'inversione, questa proprietà imposta tutte le altre

            if (this.TopMost) // se il form è sempre in primo piano
            {
                this.MinimumSize = new Size(50, 50); // permetto un size più piccolo rispetto a quello con la barra
                this.FormBorderStyle = FormBorderStyle.None; // senza barra del titolo
            }
            else
            {
                this.FormBorderStyle = FormBorderStyle.SizableToolWindow; // con barra del titolo
                this.MinimumSize = new Size(80, 160);
            }                
        }

        private void ComboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            Timer1.Interval = Convert.ToInt16(ComboBox1.SelectedItem);
        }

        private void btnInfo_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Scegli il quadrante 1,2,3,4,5,6\nScegli le lancette h,m,s\nScegli la fluidità (+fluido = +cpu)\nScegli la dimensione (resize form)\nDoppio click, nascondi il form\nClick, trascina dove vuoi", "Analog Clock - CB©2025", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        public Color GetColorAt(int x, int y)
        {
            gc.CopyFromScreen(x, y, 0, 0, new Size(1, 1), CopyPixelOperation.SourceCopy); // un pixel del desktop alle coordinate richieste
            return colorDesktop.GetPixel(0, 0); // il colore di quel pixel           
        }
    }
}
